"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
* this class handles the possible errors
* in a form
*/
var FormErrors = function () {

  /**
   * Create an instance of formerrors
   * @return {void}
   */
  function FormErrors() {
    _classCallCheck(this, FormErrors);

    this.errors = {};
  }

  /**
   * Check if the field exists in the errors
   *
   * @param  {String}  field
   * @return {Boolean}
   */


  _createClass(FormErrors, [{
    key: "has",
    value: function has(field) {
      return this.errors.hasOwnProperty(field);
    }

    /**
     * Return the error for the field
     *
     * @param  {String} field
     * @return {String}
     */

  }, {
    key: "get",
    value: function get(field) {
      if (!this.has(field)) {
        return null;
      }

      return this.errors[field][0];
    }

    /**
     * Record new errors
     *
     * @param  {Object} errors
     * @return {void}
     */

  }, {
    key: "record",
    value: function record(errors) {
      this.errors = errors;
    }

    /**
     * Clear error for specific field or for all errors
     *
     * @param  {String} field
     * @return {void}
     */

  }, {
    key: "clear",
    value: function clear(field) {
      if (!field) {
        this.errors = {};
        return;
      }

      delete this.errors[field];
    }

    /**
     * Check if there are any errors
     *
     * @return {Boolean}
     */

  }, {
    key: "any",
    value: function any() {
      return Object.keys(this.errors).length > 0;
    }
  }]);

  return FormErrors;
}();

exports.default = FormErrors;


module.exports = FormErrors;