'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RequestDataContainer = function () {

  /**
   * Set up the class.
   *
   * @param  {String} type
   * @return {this}
   */
  function RequestDataContainer(type) {
    _classCallCheck(this, RequestDataContainer);

    this.type = type;

    if (this.type == 'json') {
      this.data = {};
    } else if (this.type == 'form-data') {
      this.data = new FormData();
    } else {
      this.data = null;
    }
  }

  /**
   * Set a value in the respective key inside the data object.
   *
   * @param {String} key
   * @param {mixed} value
   */


  _createClass(RequestDataContainer, [{
    key: 'set',
    value: function set(key, value) {
      var _this = this;

      if (this.type == 'json') {
        this.data[key] = value;
      } else if (this.type == 'form-data') {
        if (Array.isArray(value)) {
          value.forEach(function (element) {
            _this.data.append(key + '[]', _this.parseToFormData(element));
          });
        } else {
          this.data.append(key, this.parseToFormData(value));
        }
      }
    }

    /**
     * Parse the value to the FormData value type.
     *
     * @param  {mixed} value
     * @return {string}
     */

  }, {
    key: 'parseToFormData',
    value: function parseToFormData(value) {
      if (typeof value === "boolean") {
        return value ? 1 : 0;
      }

      return value == null ? '' : value;
    }
  }]);

  return RequestDataContainer;
}();

module.exports = RequestDataContainer;